<?

function cn_notify($id,$type,$name,$mother_id = 0,$mother_type = 0,$mother_name = "") {
 global $CN_NOTIFICATION_BASEURL, $TOOLPATH, $TMPPATH;
 $tmp = str_replace("_CN_NOTIFICATION_OBJECT_","$type.$id",$CN_NOTIFICATION_BASEURL);
 $tmp = str_replace("_CN_NOTIFICATION_MOTHEROBJECT_","$mother_type.$mother_id",$tmp);
 $tmp = str_replace("_CN_NOTIFICATION_OBJECTNAME_",$name,$tmp);
 $tmp = str_replace("_CN_NOTIFICATION_MOTHEROBJECTNAME_",$mother_name,$tmp);
 $cmd = "$TOOLPATH/wget -b -o $TMPPATH/wget.log '$tmp' > /dev/null 2>&1";
 @system($cmd);
}



function get_tablesize($tag_type, $name, $o_id = false) {

 $tagkey = get_tagkey($tag_type, $o_id);
 $sqlpart = $tagkey["sql"];

 $sql = "SELECT id, name FROM ".sqlf_name($tag_type)."tag WHERE $sqlpart AND LOWER(name) LIKE '".strtolower(sqlslashes($name)).".%.style'";
 $rs = query($sql);
 if ($rs["num"] > 0) {
 while (list($key,$val) = each($rs["arr"])) {
 $_cell = ereg("^[^\.]*\.([A-Z])([0-9]*)", $val["name"], $regs);
 if ($_cell) {
 $_col = $regs[1];
 $_row = $regs[2];
 if ($_col > $_max_col) $_max_col = $_col;
 if ($_row > $_max_row) $_max_row = $_row;
 }
 }
 }

 $max_rows = $_max_row;
 $max_cols = ord($_max_col) - 64;

 
 $sql = "SELECT id FROM ".sqlf_name($tag_type)."tag WHERE $sqlpart AND name = '".sqlslashes($name)."'";
 $rs = query($sql);
 $tag_id = $rs["arr"][0]["id"];
 $taginfo = get_taginfo($tag_id, $tag_type, "tab");
 $d_rows = $taginfo["detail"]["rows"];
 $d_cols = $taginfo["detail"]["cols"];

 
 if ($d_rows > $max_rows) {
 $max_rows = $d_rows;
 }
 if ($d_cols > $max_cols) {
 $max_cols = $d_cols;
 }

 return array("rows"=>$max_rows,"cols"=>$max_cols);
}

function get_pageicon($status, $code, $inherited=false) {
 global $PAGE_STATUS_LANG_ICON, $PAGE_STATUS_LANG_ICON_MC;
 if ($inherited) {
 $base = $PAGE_STATUS_LANG_ICON_MC[$status];
 } else {
 $base = $PAGE_STATUS_LANG_ICON[$status];
 }
 return get_langicon( $base, $code, "content" ); 
}

function get_pageinfo($id, $sel = "page.*", $lang_icon = false) {
 global $PAGE_STATUS_ICON, $FEATURE;
 if (!$id) return false;

 if ($FEATURE["contentgroup3"]) {
 $sql = "SELECT ".sqlf_name($sel)." , contentgroup.id AS contentgroup_id, contentgroup.code, folder.node_id AS node_id FROM page LEFT JOIN contentgroup ON (contentgroup.id = page.contentgroup_id) LEFT JOIN folder ON (page.folder_id = folder.id) WHERE page.id = ".sqlf_tl_num($id)." ";
 } else {
 $sql = "SELECT ".sqlf_name($sel)." , folder.node_id AS node_id FROM page LEFT JOIN folder ON (page.folder_id = folder.id) WHERE page.id = ".sqlf_tl_num($id);
 }
 $rs = query($sql,true);
 if ($rs["num"] == 0) return false;
 $ret = $rs["arr"][0];
 $ret["tid"] = $ret["template_id"];
 $ret["cid"] = $ret["content_id"];
 if ($FEATURE["contentgroup3"] && $lang_icon) {
 $ret["icon"] = get_pageicon($ret["status"], $ret['code']);
 } else {
 $ret["icon"] = $PAGE_STATUS_ICON[$ret["status"]];
 }
 
 $ret['editorversion'] = get_folder_editorversion($ret["folder_id"]);
 
 return $ret;
}

function get_obj_icon( $type ) {
 global $T_PAGE, $T_TEMPLATE, $T_FOLDER;
 global $ICO_PAGE, $ICO_TPL, $ICO_FOLDER;
 $icon[$T_PAGE] = $ICO_PAGE;
 $icon[$T_TPL] = $ICO_TPL;
 $icon[$T_FOLDER] = $ICO_FOLDER;
 return $icon[$type];
}

function get_contentinfo($id) {
 if (!$id) return false;
 $sql = "SELECT * FROM content WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql,true);
 if ($rs["num"] == 0) return false;
 return $rs["arr"][0];
}

function get_mlinfo($id) {
 $sql = "SELECT id, name, ext, contenttype FROM ml WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql,true);
 return $rs["arr"][0];
}
function get_templateinfo($id) {
 global $ICO_TPL;
 $sql = "SELECT * FROM template WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql,true);
 return array_merge($rs["arr"][0], array('icon'=>$ICO_TPL));
}






function getMasterTemplateId($id) {
 
 
 $res = query("SELECT u.id
		FROM template t
		INNER JOIN template u ON t.channelset_id = u.channelset_id
		WHERE u.is_master = 1 AND t.channelset_id <> 0
		AND t.id = " . sql_num($id));
 
 
 if ( ! $res['arr'] ) {
 return $id;
 } else {
 return $res['arr'][0]['id'];
 }
}






function getMasterFolderId($id) {
 
 
 $res = query("SELECT g.id
		FROM folder f
		INNER JOIN folder g ON f.channelset_id = g.channelset_id
		WHERE g.is_master = 1 AND f.channelset_id <> 0
		AND f.id = " . sql_num($id));
 
 
 if ( ! $res['arr'] ) {
 return $id;
 } else {
 return $res['arr'][0]['id'];
 }
}

function get_folderinfo($id,$fullpath = false) {
 global $FEATURE ,$ICO_FOLDER, $NODE_ID;

 if (!$id) return false;

 $sql = "SELECT id, mother, pub_dir, node_id, name, cdate, edate, creator, editor, description, type_id, master_id, channel_id, channelset_id, is_master FROM folder WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql,true);
 $ret = $rs["arr"][0];
 if ($fullpath) {
 $fullpath = Array();
 $fullpath["name"] = $ret["name"];
 $fullpath["id"][] = $ret["id"];
 while ($rs["arr"][0]["mother"] != 0) {
 $sql = "SELECT id, name, mother, channelset_id FROM folder WHERE id = ".sqlf_tl_num($rs["arr"][0]["mother"]);
 $rs = query($sql,true);
 if ($FEATURE["multichannelling"] && $NODE_ID && $rs["arr"][0]["channelset_id"]) {
 $finfo = doMultichannellingFallback(T_FOLDER, $rs["arr"][0]["channelset_id"], $NODE_ID);
 } else {
 $finfo = $rs["arr"][0];
 }
 if (($finfo["mother"] == 0 && $FEATURE["no_node_isolation"]) || $finfo["mother"] != 0) {
 $fullpath["name"] = $finfo["name"]."/".$fullpath["name"];
 $fullpath["id"][] = $finfo["id"];
 }
 }
 $ret["fullpath"] = $fullpath;

 }
 $ret['icon'] = $ICO_FOLDER;

 return $ret;
}

function get_breadcrumb( $folder_id ) {
 global $STAG, $T_FOLDER, $FEATURE, $CN_LOCAL_SERVER, $PORTLETAPP_PREFIX_INTERNAL, $NODE_ID, $SESSION_TOKEN;
 $ret = "";

 if ($FEATURE["multichannelling"]) {
 
 $fc = new fetchCurl();
 $fc->setUrl($CN_LOCAL_SERVER . $PORTLETAPP_PREFIX_INTERNAL . "rest/folder/breadcrumb/$folder_id?sid=$SESSION_TOKEN&nodeId=$NODE_ID");
 $json = $fc->doRequest();
 $response = json_decode($json, true);
 $pathParts = array();

 $atposidx = "-1";
 while (list($key, $val) = each($response["folders"])) {
 $atposidx .= "-".$val['id'];
 $part = "<a href=\"$STAG&amp;do=13020&amp;FOLDER_ID=".$val['id']."&NODE_ID=$NODE_ID\" onclick=\"top.tree.location.href='$STAG&do=300&open_type=$T_FOLDER&open_id=".$val['id']."&atposidx=$atposidx';\">";
 $part .= $val['name'];
 $part .= "</a>";
 $pathParts[] = $part;
 }

 $ret = implode(" / ", $pathParts);
 } else {
 $folder_info = get_folderinfo( $folder_id, true );
 $path = $folder_info['fullpath']['id'];
 
 for ($i = count($path) - 1; $i >= 0; --$i) {
 $folder_data = get_folderinfo( $path[$i] );
 $ftree = get_folder_tree($path[$i]);
 $atposidx = build_atposidx( $ftree );
 $ret .= "<a href=\"$STAG&amp;do=13020&amp;FOLDER_ID=".$path[$i]."\" onclick=\"top.tree.location.href='$STAG&do=300&open_type=$T_FOLDER&open_id=".$path[$i]."&atposidx=$atposidx';\">";
 $ret .= $folder_data['name'];
 $ret .= "</a>";
 if ( $i > 0 ) $ret .= " / ";
 }
 }
 return $ret;
}

 
function get_folderpath($id) {
 $folder = get_folderinfo($id);
 $node = get_nodeinfo($folder["node_id"]);
 if ($node["pub_dir"] == "/") $node["pub_dir"] = "";
 return $node["host"].$node["pub_dir"].$folder["pub_dir"];
}

function get_nodeinfo($id) {
 $sql = "SELECT node.*, folder.master_id, folder.name FROM node LEFT JOIN folder ON node.folder_id = folder.id WHERE node.id = ".sqlf_tl_num($id);
 $rs = query($sql,true);
 return $rs["arr"][0];
}








function getMasterNode($nodeId, $recursive=true) {
 $r = query("SELECT g.node_id, g.master_id
		FROM node n
		INNER JOIN folder f ON n.folder_id = f.id
		INNER JOIN folder g ON f.master_id = g.id
		WHERE n.id = " . sql_num($nodeId));
 
 if ($r['num'] > 0) {
 
 if ($recursive) {
 if ($r['arr'][0]['master_id'] == 0) {
 
 return $r['arr'][0]['node_id'];
 } else {
 
 return getMasterNode($r['arr'][0]['node_id']);
 }
 } else {
 
 return $r['arr'][0]['node_id'];
 }
 } else {
 
 
 return $nodeId;
 }
}






function getMasterNodes($nodeId) {
 static $_cachedMasterNodes;

 if (!$_cachedMasterNodes) {
 $_cachedMasterNodes = array();
 }

 if (!$_cachedMasterNodes[$nodeId]) {
 $masters = array();

 $checkId = $nodeId;
 while (($masterId = getMasterNode($checkId, false)) != $checkId) {
 $masters[] = $masterId;
 $checkId = $masterId;
 }
 $_cachedMasterNodes[$nodeId] = $masters;
 }

 return $_cachedMasterNodes[$nodeId];
}







function getInheritanceMap($channelId) {
 static $_cachedInheritanceMaps;

 if (!$_cachedInheritanceMaps) {
 $_cachedInheritanceMaps = array();
 }

 if (!$_cachedInheritanceMaps[$channelId]) {
 $channels = array();
 $channels[] = $channelId;
 
 $nodeId = $channelId;
 
 while (($masterId = getMasterNode($nodeId, false)) != $nodeId) {
 $channels[] = $masterId;
 $nodeId = $masterId;
 }
 
 
 $channels[] = 0;

 
 $map = array();
 
 $channels = array_reverse($channels);
 $order = 0;
 foreach ($channels as $c) {
 $map[$c] = $order++;
 }

 $_cachedInheritanceMaps[$channelId] = $map;
 }

 return $_cachedInheritanceMaps[$channelId];
}









function doMultichannellingFallback($obj_type, $channelset_id, $channel_id) {
 $table = false;
 switch($obj_type) {
 case T_PAGE:
 $table = "page";
 break;
 case T_FOLDER:
 $table = "folder";
 break;
 case T_TEMPLATE:
 $table = "template";
 break;
 case CT_FILE:
 case T_IMAGE:
 $table = "contentfile";
 break;
 default:
 return false;
 }

 
 $inheritanceMap = getInheritanceMap($channel_id);

 
 $sql = "SELECT * FROM ".sql_name($table)." WHERE channelset_id = ".sql_num($channelset_id)." AND channel_id IN (".sqlf_value_list(implode(",", array_keys($inheritanceMap))).")";
 $rs = query($sql);
 $candidates = $rs["arr"];

 
 $channelset_order = array();
 $channelset_channel = array();
 reset($candidates);
 while (list($key, $val) = each($candidates)) {
 $cs = $val["channelset_id"];
 $channel = $val["channel_id"];

 if ($cs) {
 $order = $inheritanceMap[$channel];
 if (!$channelset_order[$cs] || $order > $channelset_order[$cs]) {
 $channelset_order[$cs] = $order;
 $channelset_channel[$cs] = $channel;
 }
 }
 }

 
 $objects = array();
 reset($candidates);
 while (list($key, $val) = each($candidates)) {
 $cs = $val["channelset_id"];
 $channel = $val["channel_id"];
 if (!$cs) {
 
 $objects[] = $val;
 } else if ($channelset_channel[$cs] == $channel) {
 
 $objects[] = $val;
 }
 }

 return $objects[0];
}

function get_folder_of_node($node_id) {
 $node = get_nodeinfo($node_id);
 return $node["folder_id"];
}
function get_fileinfo($id) {
 global $ICO_FILE, $ICO_IMG;
 $sql = "SELECT id, name, md5, folder_id, filesize, filetype, description, edate, editor, creator, cdate, sizex, sizey, dpix, dpiy, channel_id, channelset_id, is_master FROM contentfile WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql,true);
 if ( $rs["num"] == 0 )
 return array( "exists"=>false );

 $ret = array_merge($rs["arr"][0], (ereg('image',$rs['arr'][0]['filetype']))?array('icon'=>$ICO_IMG):array('icon'=>$ICO_FILE));
 $ret["exists"] = true;

 return $ret;
}

function get_usergroupinfo($group_id) {
 $sql = "SELECT * FROM usergroup WHERE id = ".sqlf_tl_num($group_id);
 $rs = query($sql,true);
 return $rs["arr"][0];
}

function get_userinfo($id) {
 if ( !$id && strlen($id) == 0 ) {
 warning( 107, "get_userinfo: invalid id($id)" );
 return array();
 }
 $sql = "SELECT * FROM systemuser WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql,true);
 $rs["arr"][0]["fullname"] = $rs["arr"][0]["firstname"]." ".$rs["arr"][0]["lastname"];
 return $rs["arr"][0];
}

function get_tagkey($type, $id = false) {

if ($type != "obj" && $type != "page" && $type != "content" && $type != "template") halt(7,"tag_getkey: invalid type($type)");

if ($type == "obj") {
 global $OBJPROP_ID, $OBJPROP;
 $O_ID = Array();
 $O_ID["type"] = $OBJPROP;
 $O_ID["id"] = $OBJPROP_ID;
 $O_TYPE = $tkey;
 $sqlpart = "obj_id = ".sqlf_value($OBJPROP_ID)." AND obj_type = ".sqlf_value($OBJPROP);
} else if ($type == "page" || $type == "content") {
 $type = "content";
 if ($id) {
 $page = get_pageinfo($id);
 } else {
 global $PAGE_ID;
 $page = get_pageinfo($PAGE_ID);
 }
 $O_ID = $page["content_id"];
 $O_TYPE = $type;
 $sqlpart = sqlf_field($O_TYPE."_id")." = ".sqlf_value($O_ID);
} else if ($type == "template") {
 global $TEMPLATE_ID;
 $O_ID = ($id)?$id:$TEMPLATE_ID;
 $O_TYPE = $type;
 $sqlpart = sqlf_field($O_TYPE."_id")." = ".sqlf_value($O_ID);
}

$ret["id"] = $O_ID;
$ret["type"] = $O_TYPE;
$ret["sql"] = $sqlpart;

return $ret;

}

function translate_tagtype( $type )
{
 global $T_CONTENT, $T_TEMPLATE, $T_CONTENTTAG, $T_TEMPLATETAG;
 if ($type == $T_CONTENT || $type == $T_CONTENTTAG) return "contenttag";
 if ($type == $T_TEMPLATE || $type == $T_TEMPLATETAG) return "templatetag";

 if ($type == "page") return "contenttag";
 else if ($type == "construct") return "globaltag";
 else if ($type == "global") return "globaltag";
 else if ($type == "template") return "templatetag";
 else if ($type == "content") return "contenttag";
 else if ($type == "obj") return "objtag";
 return $type;
}

function tagtype_is_page( $type )
{
 global $T_CONTENT, $T_CONTENTTAG;
 return $type == "page" || $type == "content" || $type == $T_CONTENT || 
 $type == $T_CONTENTTAG; 
}

function tagtype_is_objtag( $type ) {
 global $T_OBJTAG;
 return $type = "objprop" || $type == "objtag" || $type == "obj" || $type == $T_OBJTAG;
}


function get_taginfo($id,$type,$detail = "") {

 global $T_CONTENT, $T_TEMPLATE;
 if ($type == $T_CONTENT) $type = "content";
 if ($type == $T_TEMPLATE) $type = "template";

 if ($type == "page") $type = "content";
 if ($type == "content") $sqlpart = ", content_id";
 if ($type == "template_nopub") $type = "template";
 if ($type == "template") $sqlpart = ", pub";

 $sql = "SELECT name".$sqlpart.", ".sqlf_name($type)."_id, construct_id, enabled FROM ".sqlf_name($type)."tag WHERE id = ".sqlf_tl_num($id);
 $rs = query($sql,true);
 $ret = $rs["arr"][0];
 $ret["type"] = $type;
 $ret["o_id"] = $ret[$type."_id"];
 $ret["cid"] = $ret["construct_id"];

 if ($detail == "tab") {
 $sql = "SELECT part.id, value_text FROM value, part WHERE ".sqlf_name($type)."tag_id = ".sqlf_tl_num($id)." AND value.part_id = part.id AND part.type_id = 23";
 $rs = query($sql);
 $tmp = explode(";",$rs["arr"][0]["value_text"]);
 $detail = Array();
 $detail["cols"] = $tmp[0];
 $detail["rows"] = $tmp[1];
 $detail["pid"] = $rs["arr"][0]["id"];

 $sql = "SELECT info_text FROM part where id = ".sqlf_tl_num($detail["pid"]);
 $rs = query($sql);

 if ($rs["arr"][0]["info_text"]) {
 $tmp = explode(";",$rs["arr"][0]["info_text"]);
 $detail["cid"] = $tmp[2];
 }
 }

 if ($detail == "ds") {
 $sql = "SELECT id FROM part WHERE construct_id = ".sqlf_tl_num($ret["construct_id"])." AND type_id = 13";
 $rs = query($sql,true);
 if ($rs["num"] > 0) $detail = true;
 else $detail = false;
 }

 if ($detail) $ret["detail"] = $detail;

 return $ret;

}

function get_contentnoderoot($node_id) {
 global $FEATURE, $T_CONTENT, $T_DOMAIN;
 if ($FEATURE["no_node_isolation"]) {
 $sql = "SELECT id FROM tree WHERE type_id = ".sqlf_tl_num($T_CONTENT);
 $rs = query($sql,true);
 $root = $rs["arr"][0]["id"];
 $type = $T_CONTENT;
 } else {
 $sql = "SELECT id FROM folder WHERE mother = 0 AND node_id = ".sqlf_tl_num($node_id);
 $rs = query($sql,true);
 $root = $rs["arr"][0]["id"];
 $type = $T_DOMAIN;
 }

 $ret["root"] = $root;
 $ret["type"] = $type;

 return $ret;
}

function load_contentgroups() {
 global $CONTENTGROUPS;
 if (is_array($CONTENTGROUPS)) return;
 $sql = "SELECT id, name, code FROM contentgroup ORDER BY name";
 $rs = query($sql,true);
 $CONTENTGROUPS = Array();
 foreach ($rs["arr"] as $key=>$val) {
 $CONTENTGROUPS[$val["id"]] = $val;
 }
}

function get_dssource($oid,$otype,$tagname) {
 global $T_PAGE, $T_TEMPLATE;
 if ($otype == $T_PAGE) {
 $page = get_pageinfo($oid);
 $template_id = $page["template_id"];
 } else if ($otype == $T_TEMPLATE) {
 $template_id = $oid;
 } else halt(7,"get_dssource: invalid otype($otype) oid($oid) tagname($tagname)");
 $sql = "SELECT value.value_text FROM templatetag, value, part
	WHERE template_id = ".sqlf_tl_num($template_id)." AND name = '".sqlf_escaped($tagname)."' AND 
	value.part_id = part.id AND part.type_id = 13
	AND value.templatetag_id = templatetag.id";
 $rs = query($sql);
 return $rs["arr"][0]["value_text"];
}

function get_recfolderids($id) {

 $folder = Array();
 $folder[] = $id;

 $sql = "SELECT id FROM folder WHERE mother = ".sqlf_tl_num($id);
 $rs = query($sql,true);

 foreach($rs["arr"] as $row) {
 $ret = get_recfolderids($row["id"]);
 $folder = array_merge($folder,$ret);
 }

 return $folder;

}

function get_languageinfo($language_id) {
 $sql = "SELECT * from language WHERE id = ".sqlf_tl_num($language_id);
 $rs = query($sql);
 return $rs["arr"][0];
}









function get_folder_structure($type, $objects, $maxentries = 6) {
 if (count($objects) == 0) {
 return array();
 }

 
 switch($type) {
 case T_PAGE:
 $table = "page";
 $folder_col = "folder_id";
 break;
 case T_FOLDER:
 $table = "folder";
 $folder_col = "mother";
 break;
 case CT_FILE:
 case T_IMAGE:
 $table = "contentfile";
 $folder_col = "folder_id";
 break;
 default:
 return null;
 }
 $sql = "SELECT $table.id, ".sqlf_field("f$maxentries.mother").", froot.name node_name";
 $join = "";
 for ($i = 1; $i <= $maxentries; ++$i) {
 $sql .= ", ".sqlf_field("f$i.name")." ".sqlf_field("f$i"."_name");
 if ($i == 1) {
 $join .= "LEFT JOIN folder ".sqlf_table("f$i")." ON ".sqlf_field("$table.$folder_col")." = ".sqlf_field("f$i.id")." ";
 } else {
 $join .= "LEFT JOIN folder ".sqlf_table("f$i")." ON ".sqlf_field("f".($i - 1).".mother")." = ".sqlf_field("f$i.id")." ";
 }
 }
 $join .= "LEFT JOIN folder froot ON f1.node_id = froot.node_id AND froot.mother = 0";
 $sql .= " FROM $table $join WHERE $table.id IN (".implode(",", sqlf_tl_num_array($objects)).")";
 $rs = query($sql);

 $paths = array();
 foreach($rs["arr"] as $row) {
 $path = "";
 
 if ($row["mother"] && $row["mother"] != 0) {
 $path .= $row["node_name"]."/.../";
 }

 for ($i = $maxentries; $i > 0; $i--) {
 if ($row["f$i"."_name"]) {
 $path .= $row["f$i"."_name"] . "/";
 }
 }

 $paths[$row["id"]] = $path;
 }

 return $paths;
}








function get_language_variants($pageId, $nodeId = null, $localOnly = false) {
 global $FEATURE, $NODE_ID, $CN_LOCAL_SERVER, $SESSION_TOKEN;

 if ($FEATURE["multichannelling"]) {
 if (!$nodeId) {
 $nodeId = $NODE_ID;
 }
 $url = $CN_LOCAL_SERVER . $PORTLETAPP_PREFIX_INTERNAL . "rest/page/load/$pageId?sid=$SESSION_TOKEN&langvars=true";
 if ($nodeId) {
 $url .= "&nodeId=$nodeId";
 }
 $fc = new fetchCurl();
 $fc->setUrl($url);
 $json = $fc->doRequest();
 $rs = json_decode($json, true);

 $ret = array();
 if ($rs['page'] && is_array($rs['page']['languageVariants'])) {
 while (list($k, $langvar) = each($rs['page']['languageVariants'])) {
 if (!$localOnly || !$langvar["inherited"]) {
 $ret[] = $langvar['id'];
 }
 }
 }

 return $ret;
 } else {
 $sql = "SELECT id FROM page WHERE contentset_id IN (SELECT contentset_id FROM page WHERE id = ".sql_num($pageId).") AND contentset_id != 0 AND contentset_id IS NOT NULL";
 $rs = query($sql);
 $ret = array();
 foreach ($rs["arr"] as $row) {
 $ret[] = $row["id"];
 }

 return $ret;
 }
}

function get_global_id($type, $localid) {
}





function get_folder_editorversion($folder_id) {
 $f = get_folderinfo($folder_id);
 $node = get_nodeinfo($f["node_id"]);
 return $node["editorversion"];
}









function getTemplates($folderId, $nodeId) {
 global $FEATURE, $CN_LOCAL_SERVER, $SESSION_TOKEN, $PORTLETAPP_PREFIX_INTERNAL;

 if ($FEATURE["multichannelling"]) {
 
 $fc = new fetchCurl();
 $url = $CN_LOCAL_SERVER . $PORTLETAPP_PREFIX_INTERNAL . "rest/folder/getTemplates/$folderId?sid=$SESSION_TOKEN&nodeId=$nodeId&checkPermission=false";
 $fc->setUrl($url);
 $json = $fc->doRequest();
 $templates = array();
 $rs = json_decode($json, true);
 while (list($k, $template) = each($rs['templates'])) {
 
 if ($template['masterId']) {
 $templates[$template['masterId']] = $template['name']; 
 } else {
 $templates[$template['id']] = $template['name']; 
 }
 }
 } else {
 $sql = "SELECT template.id, template.name, LOWER(template.name) AS l_name FROM template, template_folder
		WHERE template.id = template_folder.template_id AND template_folder.folder_id = ".sqlf_tl_num($folderId)."
		ORDER BY l_name";
 $rs = query($sql);
 $templates = reduce_array($rs["arr"],"id","name");
 if (!is_array($templates)) {
 $templates = Array();
 }
 }

 return $templates;
}





function getActivatedNodeFeatures() {
 global $FEATURES_PER_NODE, $FEATURE;
 $node_features = array();

 
 foreach ($FEATURES_PER_NODE as $feature) {
 
 if ($FEATURE[$feature]) {
 $node_features[] = $feature;
 }
 }

 return $node_features;
}

?>
